Subject: Re: Use function smgrclose() to replace the loop

From: Junwang Zhao <[email-masked]>
Date: Tue, 15 Oct 2024 18:55:50 +0800

On Mon, Oct 14, 2024 at 6:30 PM Ilia Evdokimov
<[email-masked]> wrote:
>
>
> On 14.08.2024 09:32, Steven Niu wrote:
> > Hi, Kirill, Junwang,
> >
> > I made this patch to address the refactor issue in our previous email
> > discussion.
> > https://www.postgresql.org/message-id/flat/CABBtG=[email-masked]
> >
> >
> > That is, the for loop in function smgrdestroy() and smgrdounlinkall
> > can be replaced with smgrclose().
> >
> > for (forknum = 0; forknum <= MAX_FORKNUM; forknum++)
> >     smgrsw[reln->smgr_which].smgr_close(reln, forknum);
> > -->
> > smgrclose(rels[i]);
> >
> > Please let me know if you have any questions.
> >
> > Best Regards,
> > Steven from Highgo.com
>
> Hello,
>
> Are you sure we can refactor loop by 'smgrclose()'? I see it is not
> quite the same.

smgrclose does more by setting smgr_cached_nblocks[] and smgr_targblock
to InvalidBlockNumber, I see no harm with the replacement, not 100% sure
though.

> Regards,
> Ilia Evdokimov,
> Tantor Labs LLC.

-- 
Regards
Junwang Zhao